package com.googlecode.jpattern.orm.logger;

import com.googlecode.jpattern.logger.ILogger;
import com.googlecode.jpattern.logger.ILoggerFactory;
import com.googlecode.jpattern.logger.NullLoggerFactory;

/**
 * 
 * @author Francesco Cina
 *
 * 04/giu/2011
 */
public abstract class OrmLogger {

	private static ILoggerFactory ormLoggerFactory;

	public static void setOrmLoggerFactory(ILoggerFactory ormLoggerFactory) {
		OrmLogger.ormLoggerFactory = ormLoggerFactory;
	}

	public static ILogger getOrmLogger(Class<?> clazz) {
		if ( ormLoggerFactory == null ) {
			ormLoggerFactory = new NullLoggerFactory();
		}
		return ormLoggerFactory.logger(clazz);
	}
	
}
